/**
 * Get the current breakpoint from CSS variable.
 * Used for conditional logic and/or rendering in component JS
 * by matching the current breakpoint with values defined in common/defs/breakpoints.
 */
export declare function getCurrentBreakpoint(): string;
export declare const BREAKPOINT_VIEWPORTS: {
    sm: {
        name: string;
        styles: {
            width: string;
            height: string;
        };
    };
    md: {
        name: string;
        styles: {
            width: string;
            height: string;
        };
    };
    lg: {
        name: string;
        styles: {
            width: string;
            height: string;
        };
    };
    xl: {
        name: string;
        styles: {
            width: string;
            height: string;
        };
    };
    max: {
        name: string;
        styles: {
            width: string;
            height: string;
        };
    };
};
//# sourceMappingURL=breakpoints.d.ts.map